#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.
################################################################################
# qhold: defines the layout and functions of the select hold job dialog box.
proc qhold {} {
  global jobsSelected LABELFONT jobidField SERVER_HOSTS cmdpath \
	 qholdDialogBox activeWindow qholdv

  busy_cursor
## Bring up the standard Dialog box ##
  set qholdDialogBox ".hold"
  set dbox [popupDialogBox $qholdDialogBox "Hold Job Dialog"]
  set activeWindow($qholdDialogBox) 1
  set dbox_top    [lindex $dbox 0]
  set dbox_bottom [lindex $dbox 1]

## BOTTOM PART ##
  set cmdButtons \
  [buildCmdButtons $dbox_bottom {{{hold hold} {cancel cancel} {help help}}} x 0 10 3]

  set cmdFrame  [lindex $cmdButtons 0]
  set cmdHold   [lindex $cmdButtons 1]
  set cmdCancel [lindex $cmdButtons 2]
  set cmdHelp   [lindex $cmdButtons 3]
 
  $cmdHold configure -command {

    if { [string compare $qholdv(other) ""] == 0 && \
         [string compare $qholdv(system) ""] == 0} {
      set qholdv(user) u
      set exitcode [win_cmdExec $qholdDialogBox "$cmdpath(QHOLD) $jobsSelected"]
    } else {
      set exitcode [win_cmdExec $qholdDialogBox "$cmdpath(QHOLD) -h $qholdv(user)$qholdv(other)$qholdv(system) $jobsSelected"]
    }

    if {$exitcode == 0} {
      after 500 [list getdata $SERVER_HOSTS 1]
      destroy $qholdDialogBox
    }
  }
  $cmdCancel configure -command [list destroy $qholdDialogBox]

  $cmdHelp configure -command {xpbs_help hold $qholdDialogBox}
## TOP PART ##
  frame $dbox_top.header -height 10m -width 10m
  frame $dbox_top.footer -height 10m -width 10m
  frame $dbox_top.e
  frame $dbox_top.c
  frame $dbox_top.empty1 -width 10m
  frame $dbox_top.empty2 -width 10m

  set jobidbox [buildFullListbox $dbox_top.e 40x3 "" xyscroll 0]
  set jobidFrame [lindex $jobidbox 0]
  set jobidField [lindex $jobidbox 3]
  $jobidField configure -relief sunken
  bind_text_readonly $jobidField

  foreach el $jobsSelected {
    $jobidField insert end $el
  }

  set chkbox [buildCheckboxes $dbox_top.c \
                   {{{user user} {other other} {system system}}} column 0]
  set chkboxFrame  [lindex $chkbox 0]
  set chkboxUser   [lindex $chkbox 1]
  set chkboxOther  [lindex $chkbox 2]
  set chkboxSystem [lindex $chkbox 3]

  $chkboxFrame configure -relief groove -borderwidth 2

  $chkboxUser   configure -variable qholdv(user) -onvalue u -offvalue ""
  $chkboxOther  configure -variable qholdv(other) -onvalue o -offvalue ""
  $chkboxSystem configure -variable qholdv(system) -onvalue s -offvalue ""

  set qholdv(user)   u
  set qholdv(other)  ""
  set qholdv(system) ""

   
  label $dbox_top.chkboxLabel1 -text "Place" -font $LABELFONT
  label $dbox_top.chkboxLabel2 -text "hold(s) on job(s):" -font $LABELFONT

## ARRANGEMENT ON SCREEN

  pack $dbox_top.header -side top
  pack $dbox_top.empty1 $dbox_top.chkboxLabel1 -side left -anchor nw
  pack $chkboxFrame -after $dbox_top.chkboxLabel1 -anchor nw -side left -padx 2
  pack $dbox_top.chkboxLabel2 $jobidFrame $dbox_top.empty2 -anchor nw -side left
  pack $dbox_top.footer -before $chkboxFrame -side bottom


  register_default_action $qholdDialogBox $cmdCancel
  tkwait visibility $qholdDialogBox
  remove_busy_cursor
  catch {tkwait window $qholdDialogBox}
  set activeWindow($qholdDialogBox) 0
  catch {unset qholdv}
}
